function Destroy(self)
	
	for Act in MovableMan.Actors do
		if Act.Team ~= self.Team then
			local Trace = SceneMan:ShortestDistance(self.Pos, Act.Pos, false)
			if Trace.Magnitude - Act.Radius < 280 then
				if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Trace, 0, 128) < 1500 then
					-- We have LOS to this actor
					self.StunTarget = Act
					break
				end
			end
		end
	end
	
	if self.StunTarget then
		-- Check if we can see our target
		local targetFound = false
		if MovableMan:IsActor(self.StunTarget) then
			local Trace = SceneMan:ShortestDistance(self.Pos, self.StunTarget.Pos, false)
			if Trace.Magnitude - self.StunTarget.Radius < 300 then
				if SceneMan:CastStrengthSumRay(self.Pos, self.Pos + Trace, 0, 128) < 1500 then
					-- We have LOS to the target
					targetFound = true
				end
			end
		end
		
		if targetFound then
		
			self.StunTarget.Status = 1; -- Dislodge
			local rand = math.random(0,19);
			if rand == 0 then
				self.StunTarget:GetController():SetState(Controller.MOVE_LEFT, true);
			else
				self.StunTarget:GetController():SetState(Controller.MOVE_RIGHT, true);
			end
			
			self.StunTarget:SetAimAngle(math.random(math.pi/-2, math.pi/2));
			self.StunTarget:FlashWhite(120); 
			self.StunTarget:GetController():SetState(Controller.WEAPON_FIRE, false);
			self.StunTarget:GetController():SetState(Controller.BODY_JUMPSTART,false);
			self.StunTarget:GetController():SetState(Controller.MOVE_RIGHT,false);
			self.StunTarget:GetController():SetState(Controller.MOVE_LEFT,false);

		else
			self.StunTarget = nil
		end
	end
end