
function Create(self)

	self.parent = nil;
	self.pullTimer = Timer();
	self.smokeTimer = Timer();
	self.initialTimer = Timer(); -- workaround for it smoking at creation, relic from old code

	self.newMag = false;
	self.chamber = false;		--
	--self.pullTimer:Reset();	--
	self.num = math.pi;		--
	self.sfx = true;		--
	self.sfxSetShot = true;
	self.sfxSetTail = true;
	self.sfxSetMech = true;
	
	self.negNum = 0;
	self.sLength = self.SharpLength;
	self.ShakeRange = 6
	self.sRange = self.ShakeRange
	self.lifeTimer = Timer();
	self.lifeTimerReset = false

	local actor = MovableMan:GetMOFromID(self.RootID);
	if actor and IsAHuman(actor) then
		self.parent = ToAHuman(actor);
	end
end

function Update(self)


	if self.FiredFrame then	

		self.justShot = true;


		if self.sfxSetShot ~= false then

			sfxSetShot = CreateAEmitter("Shot CCU Plasma Rifle");
			sfxSetShot.Pos = self.Pos;
			MovableMan:AddParticle(sfxSetShot);

		end

		if self.sfxSetMech ~= false then

			sfxSetShot = CreateAEmitter("Mech CCU Plasma Rifle");
			sfxSetShot.Pos = self.Pos;
			MovableMan:AddParticle(sfxSetShot);

		end


		local Vector2 = Vector(0,-700);

		local Vector2Left = Vector(0,-700):RadRotate(45);

		local Vector2Right = Vector(0,-700):RadRotate(-45);

		local Vector3 = Vector(0,0);

		local Vector4 = Vector(0,0);

		self.ray = SceneMan:CastObstacleRay(self.Pos, Vector2, Vector3, Vector4, self.RootID, self.Team, 128, 7);

		self.rayRight = SceneMan:CastObstacleRay(self.Pos, Vector2Right, Vector3, Vector4, self.RootID, self.Team, 128, 7);

		self.rayLeft = SceneMan:CastObstacleRay(self.Pos, Vector2Left, Vector3, Vector4, self.RootID, self.Team, 128, 7);

		if self.ray < 0 or self.rayRight < 0 or self.rayLeft < 0 then	
		
			if self.sfxSetTail ~= false then

				sfxSetTail = CreateAEmitter("Tail CCU Plasma Rifle");
				sfxSetTail.Pos = self.Pos;
				MovableMan:AddParticle(sfxSetTail);

			end

		else

	
			if self.sfxSetTail ~= false then

				sfxSetTail = CreateAEmitter("Tail CCU Plasma Rifle Indoors");
				sfxSetTail.Pos = self.Pos;
				MovableMan:AddParticle(sfxSetTail);

			end	
	
		end

	end


	local actor = MovableMan:GetMOFromID(self.RootID);
	if actor and IsAHuman(actor) then
		self.parent = ToAHuman(actor);
	else
		self.parent = nil;
	-- cock and load on pickup
		--self.chamber = true;	--
		--self.pullTimer:Reset();	--
		--self.num = math.pi;	--
		--self.sfx = true;	--
	end

	if self.HFlipped then
		self.negNum = -1;
	else
		self.negNum = 1;
	end

	if self.parent == nil and self.chamber == true then
		
		self.chamber = false;
		if self.pullTimer:IsPastSimMS(450) then
		
		
		else
			self.stoppedPremature = true;
		end
		self:RemoveNumberValue("ChamberRot")
		self:RemoveNumberValue("Chambering")

	end
	if self.parent then	
	
		-- if self.parent.PresetName == "Heavy Trooper" then
			-- self.StanceOffset = Vector(8, 4);
			-- self.SharpStanceOffset = Vector(12, 2.5);
		-- else
			-- self.StanceOffset = Vector(2, 4);
			-- self.SharpStanceOffset = Vector(5, 2);
		-- end
		
		if self.Magazine then
		
			self.smokeApplied = false;
		else
			
			if self.smokeApplied == false then
				for i = 1, 2 do
					Effect = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
					if Effect then
						Effect.Pos = self.Pos + Vector(4 * self.negNum, 5):RadRotate(self.RotAngle)
						Effect.Vel = (self.Vel + Vector(-4*self.negNum,5):RadRotate(self.RotAngle))
						MovableMan:AddParticle(Effect)
					end
				end
				if math.random(100) > 50 then
					Effect = CreateMOSParticle("Side Thruster Blast Ball 1", "Base.rte")
					if Effect then
						Effect.Pos = self.Pos + Vector(4 * self.negNum, 5):RadRotate(self.RotAngle)
						Effect.Vel = (self.Vel + Vector(-4*self.negNum,5):RadRotate(self.RotAngle))
						MovableMan:AddParticle(Effect)
					end
				end
				self.smokeApplied = true;
			end

		end
		if self.chamber == true then
			self:SetNumberValue("ChamberRot", self.RotAngle)
			self:SetNumberValue("Chambering", 1)
			self:Deactivate();
			--self.parent:GetController():SetState(Controller.WEAPON_FIRE,false);

			if self.pullTimer:IsPastSimMS(450) then
				--self.parent:GetController():SetState(Controller.AIM_SHARP,false);
				--self.Frame = 1;

				if self.sfx ~= false then
					sfx = CreateAEmitter("Chamber " .. self.PresetName);
					sfx.Pos = self.Pos;
					MovableMan:AddParticle(sfx);

					self.sfx = false;
				end

				self.RotAngle = self.RotAngle +self.negNum*math.sin(self.num)/8;

				self:SetNumberValue("ChamberRot", self.RotAngle)

				self.num = self.num - math.pi*0.060;
			end

			if self.num <= 0 then

				self.num = 0;
				self.chamber = false;
				self.ShakeRange = self.sRange
				self:RemoveNumberValue("Chambering")
			end
		end
	end
end