function Create(self)
	self.LifeTimer = Timer();
	self.StunTimer = Timer();
	self.SpazTimer = Timer();
	self.FlashTimer = Timer();

	self.detectWidthAndHeight = 60;
	self.spaceSkip = 1;

	self.scanDots = self.detectWidthAndHeight/self.spaceSkip
	self.backAmount = self.detectWidthAndHeight*(-0.5);

	self.stundelay = 0; -- delay before stunning (MS)
	self.stuntime = 300; -- how long target is stunned (MS)
	self.spazdelay = 100; -- amount of time between spazing (MS)

end

function Update(self)

	if self.target == nil then
		if self.LifeTimer:IsPastSimMS(80) then
			self.ToDelete = true;
		end
		for x = 1, self.scanDots do
			for y = 1, self.scanDots do
				local checkPos = self.Pos + Vector(self.backAmount+(x*self.spaceSkip),self.backAmount+(y*self.spaceSkip));
				if SceneMan.SceneWrapsX == true then
					if checkPos.X > SceneMan.SceneWidth then
						checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
					elseif checkPos.X < 0 then
						checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
					end
				end
				local moCheck = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
				if moCheck ~= 255 then
					local actor = MovableMan:GetMOFromID( MovableMan:GetMOFromID(moCheck).RootID );
					if MovableMan:IsActor(actor) and actor.Team ~= self.Sharpness then
						if canParaFlash then
							ToActor(actor):FlashWhite(250);
						end
						ToActor(actor):GetController():SetState(Controller.BODY_JUMP,false);
						ToActor(actor):GetController():SetState(Controller.BODY_JUMPSTART,false);
						ToActor(actor):GetController():SetState(Controller.BODY_CROUCH,true);
						ToActor(actor):GetController():SetState(Controller.PIE_MENU_ACTIVE,false);
						ToActor(actor):GetController():SetState(Controller.WEAPON_FIRE,false);
						ToActor(actor):GetController():SetState(Controller.AIM_SHARP,false);
						ToActor(actor):GetController():SetState(Controller.MOVE_RIGHT,false);
						ToActor(actor):GetController():SetState(Controller.MOVE_LEFT,false);
					end
				end
			end
		end
		if self.LifeTimer:IsPastSimMS(80) then
			self.ToDelete = true;
		end
	end

end