function Create(self)
	self.lastVel = 0;
	self.changeCounter = 0;
	self.minBlipDelay = 100;
	self.medBlipDelay = 250;
	self.maxBlipDelay = 500;
	self.blipdelay = 500;
end

function Update(self)
	if self.Fuze then
		if self.changeCounter == 0 and self.Fuze.ElapsedSimTimeMS > 1000 then
			self.changeCounter = 1;
			self.blipdelay = self.maxBlipDelay;
		end

		if self.changeCounter == 1 and self.Fuze.ElapsedSimTimeMS > 2000 then
			self.changeCounter = 2;
			self.blipdelay = self.medBlipDelay;
		end

		if self.changeCounter == 2 and self.Fuze.ElapsedSimTimeMS > 3000 then
			self.changeCounter = 3;
			self.blipdelay = self.minBlipDelay;
		end
		if self.sfx ~= false then
			sfx = CreateAEmitter("CCU Grenade Throw");
			sfx.Pos = self.Pos;
			MovableMan:AddParticle(sfx);
			self.sfx = false;
		end
		if self.blipTimer:IsPastSimMS(self.blipdelay) then
			self.blipTimer:Reset();
			local soundfx = CreateAEmitter("CCU Grenade Beep");
			soundfx.Pos = self.Pos;
			MovableMan:AddParticle(soundfx);
		end
		if self.Fuze:IsPastSimMS(4000) then
			local Payload = CreateMOSRotating("CCU Grenade Payload", "CCU.rte")
			if Payload then
				Payload.Pos = self.Pos
				MovableMan:AddParticle(Payload)
				Payload:GibThis()
			end
			
			self:GibThis()
		end
	elseif self:IsActivated() then
		self.blipTimer = Timer();
		self.Fuze = Timer()
	end
	if self.ID == self.RootID then
		if self.thrown == false then
			if self.HFlipped == true then
				self.negNum = -1;
			else
				self.negNum = 1;
			end
			self.AngularVel = self.AngularVel - self.Vel.Largest*self.negNum;

			self.thrown = true;
		end

	else
		self.thrown = false;
	end

	self.lastVel = self.Vel.Magnitude;
end