
dofile("Base.rte/Constants.lua")
dofile("Base.rte/Actors/AI/HumanAI.lua")	--dofile("Base.rte/Base.rte/Actors/AI/HumanAI.lua")

function Create(self)
	self.AI = NativeHumanAI:Create(self)
	
	--------- Health Regen -------
	self.HealTimer = Timer()
	self.HealTime = 1000
	self.HealAmount = 1
	self.HealthRegenMin = 10
	self.HealthRegenMax = 100
	------------------------------
	
end

function Update(self)
	if self.HealTimer:IsPastSimMS(self.HealTime) and not self:IsDead() and self.Health > self.HealthRegenMin and self.Health < self.HealthRegenMax then
		self.Health = math.min(100,self.Health + self.HealAmount)
		self.HealTimer:Reset()
	end
end

function UpdateAI(self)
	self.AI:Update(self)
end
